=pod

Module O_I.pm 

A component of the checker group of programs for monitoring applications, databases, networks, 
all types of servers, and more. By Nova Software, Inc. 

Copyright  by Nova Software, Inc. 2018  All rights reserved.  http://www.nova-sw.com

=cut
  package O_I ; our $VERSION = 0.180424; use strict; use warnings; use sigtrap; use O_B 0.170824; use O_M 0.170824; use O_U 0.170824;
use O_L 0.170824; use O_D 0.170824; use HTTP::Daemon ; use HTTP::Status; use File::Copy; use Data::Dumper; $| = 1; my $nfI = txB;    my $bwI = riB() =~/^$nfI/ ? $nfI : '';  my $iaI = kbB() ? '.cmd'  : '' ; my @ynI = (); @ynI = ('Appchkr', cwM(191), $bwI.'appchkr')  if -f "appchkr$iaI"; @ynI = ('DBchkr', cwM(192), $bwI.'dbchkr')  if -f "dbchkr$iaI"; @ynI = ('Facilitychkr', cwM(193), $bwI.'facilitychkr')  if -f "facilitychkr$iaI"; @ynI = ('Networkchkr', cwM(194), $bwI.'networkchkr')  if -f "networkchkr$iaI"; @ynI = ('Securitychkr', cwM(195), $bwI.'securitychkr')  if -f "securitychkr$iaI"; @ynI = ('Serverchkr', cwM(196), $bwI.'serverchkr')  if -f "serverchkr$iaI"; @ynI = ('Sohochkr', cwM(197), $bwI.'sohochkr')  if -f "sohochkr$iaI"; @ynI = ('Testchkr', cwM(198), $bwI.'testchkr')  if -f "testchkr$iaI"; die seM.cwM(68) unless @ynI;
my $v1I = '.'.xhB()."$ynI[2] uwi ";  my $jmI = "$ynI[0] on ".bhB();   my $jzI = nmB.xhB().riB().'.' ; sub zlI { $jzI.scB} sub lmI { $jzI.kdB} gxU(__PACKAGE__);   sub huI { jsB(shift); dfU(2);  my $kvI = gmU();  die "$kvI\n" if $kvI; my $poI = cfB()."\n".bkB.riB().", release ".skB().", on ".bhB()."\n" ."Base directory: ".w1B()."\nNova Software, www.nova-sw.com"; my $tmp = $_[0] ? $_[0] : '' ; my $lqI =  $tmp eq acB ? shift : 0 ;   my $sfI = 0; if (kbB())  { if ($_[0] and $_[0] eq m2B) {  shift; my $zuI = nmB().xhB().'startup_'.riB().'.txt' ; 
if (open STDOUT, ">$zuI") { print "\n".cfB.' '.riB()."  pid = $$\n" ; open STDERR, ">>$zuI" ; }  else { wmL cwM( 69, $zuI, $! ) ; } $sfI = shift; $sfI ||= uuB;  } else {   print "$poI\n";  $sfI = lxN($_[0]);  bxU(skB(), m2B, @_) unless $lqI;  } }  else {  print "$poI\n";  $sfI = lxN(shift); }
klU(zlI, $lqI); shL(" $poI"); lvL(lmI());  my $keI = hsI($sfI); $poI = 'Make text web pages.'; $poI .= `$v1I  -makealltext 2>&1`;   shL($poI); tcI($keI);  } gxU('O_D');  sub lxN { my $zyI = rdU($_[0], cjB, peB) if $_[0] ;  die seM."$zyI\n" if $zyI;             u2U( zlI() );   print cwM( 70) if ffB() ; my $sfI = $_[0] ? $_[0] : uuB ;  my $poI = cwM( 199, $ynI[0], bhB(), $sfI ); $poI   .= cwM( 200, rfB(), $sfI)  unless rfB() eq kcB; print $poI; qmU(uwB, $sfI) ;
return $sfI;  } sub hsI { my $sfI = shift; my $fmI = eyI($sfI); shL(dyM( 78, $sfI, bhB() ) ); my $kkI = inet_ntoa($fmI->sockaddr); my $lfI = join '', `nslookup $kkI 2>&1`;  if ($lfI =~/can\'t find/) { $lfI = ''; } else { my ($nnI, $nhI) = $lfI =~/name.?(([a-z][\w\-]\.){4})/i;   $lfI = $nhI; } my $ttI = "http://$kkI:$sfI/"; $ttI .= " or to http://$lfI:$sfI/" if $lfI; shL( cwM(201, $ttI)); print cwM(201, $ttI)."\n";  return $fmI;
} {   my $i7I = uuB; sub eyI { my $sfI = shift; $i7I = $sfI if $sfI;  my $fmI = HTTP::Daemon->new(LocalAddr => bhB(), LocalPort => $i7I, Listen => 5, Proto => 'tcp', Timeout => fhB ,   Blocking => 1, ); mtL  dyM(79, $!)  unless ref $fmI; $fmI;  } } sub tcI { my ($fmI ) = @_; my $g3I = ''; 
while (1) {  while (my $rgI = $fmI->accept('HTTP::Daemon::ClientConn')) {   shL('CONNECTED: '. $rgI->peerhost()); my $aeI = $fmI->timeout(wtB) ;   while (my $rpI = $rgI->get_request) {  opL "request req is ".Dumper $rpI if ffB; my $puI = $rpI->method; my $dqI = $rpI->uri; my $m1I = $rpI->headers->user_agent ; my $mpI = ''; if ($g3I ne $m1I) { $g3I = $m1I; $mpI ="\nUA = $m1I"; } shL("REQUEST: $puI  $dqI  $mpI"); my $n1I = ''; my $biI = pmI($rpI) unless $dqI =~/\.css$|\.gif$|\.png$|\.ico$|\.js$/ ; if ( $biI ) { shL($biI); my $cyI = HTTP::Response->new(401, 'Authorization Required');
$cyI->headers->www_authenticate( 'Basic', realm => $jmI ); $cyI->content(''); opL "rsp is ".Dumper($cyI) if ffB(); $n1I = $rgI->send_response( $cyI );  $n1I .= ' Sent 401'; }   elsif ($puI eq 'GET' or $puI eq 'POST') { my ($xsI, $pyI) = xuT ($rpI); if ($xsI) { $n1I = $rgI->send_file_response($pyI); } else { my $cyI = HTTP::Response->new(200, 'OK'); $cyI->content($pyI); opL "rsp is ".Dumper($cyI) if ffB(); $n1I = $rgI->send_response($cyI); } } elsif ($puI eq 'HEAD') { my $cyI = HTTP::Response->new(200, 'OK');
$cyI->content('');  $n1I = $rgI->send_response($cyI); } else { $n1I = dyM(80, $rpI->method) ; $rgI->send_error(RC_METHOD_NOT_ALLOWED, $n1I); } shL("RESULT: $n1I") if $n1I; last; }  $rgI->close;   shL(dyM(81, $rgI->reason)); undef($rgI); if (ref $fmI) { my $tlI = $fmI->timeout(fhB) ;  } else {  $fmI = eyI(); shL(dyM(82)); }
fxL(lmI, 100*1024*1024, 100);   }  unless ( ref $fmI) {  shL(dyM(83)); }  }  }  gxU('O_L');  {  my $iwI = ' hidden="hidden" disabled="disabled" ';  my $mcI  = 'style="display:none;"'; my $n2I = {   version     => skB(), heading     => cwM(202, $ynI[0], $ynI[1] ), datetime    => 'Date and Time ', }; my %ntI = (  cfgf => {dir  => lhB, ext  => b1B, type => 'Cfg',
txt  => 'cfg', url  => lhB.'/',   act  => cwM(203), }, logf => {dir  => vjB, ext  => kdB, type => 'Log', txt  => 'log', url  => vjB.'/', act  => cwM(204), }, rptf => {dir  => nvB, ext  => ycB, type => 'Report', txt  => 'report', url  => nvB.'/', act  => cwM(204), }, strtf => {dir  => lhB, ext  => b1B,
type => 'Start', txt  => 'cfg', url  => 'start/', act  => cwM(205), }, stpf => {dir  => cpB, ext  => scB, type => 'Stop', txt  => cwM(206), url  => 'stop/', act  => cwM(207), }, smpf => {dir  => ilB,  ext  => xqB, type => 'Sample', txt  => 'sample', url  => ilB.'/', act  => cwM(208), }, );
sub xuT { my ($rpI) = @_ ; my $n2I = {  version         => skB(), heading         => cwM(202, $ynI[0], $ynI[1] ), datetime        => 'Date and Time ', css             => jsB().'/'.mzB.'/appchkr.css', datetime        => h3U('usa'), main_pre        => '', size            => 1, file_name       => '', r1_off          => $iwI, r2_off          => $iwI, r3_off          => $iwI, sel_off         => $iwI, t_off           => $iwI, u_off           => $iwI, sbmt_off        => $iwI, sbmt2_off       => $iwI, submit1         => cwM(209),
label1          => cwM(210),  label2          => cwM(211),  label3          => cwM(212),  r_no_display    => $mcI, t_no_display    => $mcI, u_no_display    => $mcI, r1_action       => 'view', r2_action       => 'edit', r3_action       => 'delete', target          => '_blank', main_title      => cwM(213, $ynI[0] ), message         => '',  }; my $tmpl_base = jsB().xhB().mzB.xhB(); my $tmpl_path = $tmpl_base . 'appchkr.tmpl'; my $pxI = $tmpl_base . 'plain.tmpl'; my $xsI = 1; my $vnI = '';  if($rpI->uri->path =~/(\w+)\.pre$/   or 
$rpI->uri->path eq '/' ) {  my $cbI = $1; $cbI ||= 'q'; $cbI =~s/_/ /; my %ooI = (bbB()); my $zuI = jsB().xhB().mzB.xhB().$ooI{"-$cbI"}.'.'.prB;  my @tmp = yaU($zuI); my $tmp = join '', @tmp; reI(\$tmp);   $n2I->{main_pre} = $tmp; }  elsif($rpI->uri->path =~/(\w+)\.sel$/) { my $cbI = $1; my @dwI = ngI($cbI); if ($dwI[0] =~/^\*\*\*aqM/) {  $n2I->{main_pre} = $dwI[0]; } else { $n2I->{sel_off} = $n2I->{sbmt_off} = ''; if ($cbI eq 'cfgf') {
$n2I->{r1_off} = $n2I->{r3_off} = $n2I->{label2} = ''; $n2I->{r_no_display} = ''; $n2I->{u_off} = $n2I->{sbmt2_off} = '';  $n2I->{u_no_display} = ''; } elsif ($cbI eq 'smpf') { $n2I->{r1_off} = $n2I->{r2_off} = $n2I->{r_no_display} = ''; $n2I->{r3_off} = $iwI; $n2I->{label2} = cwM(214); $n2I->{label3} = ''; $n2I->{r2_action} = 'copy'; } elsif ($cbI eq 'strtf' or $cbI eq 'stpf') { $n2I->{submit1} = $ntI{$cbI}->{type}; } $n2I->{main_p} = cwM(215, $ntI{$cbI}->{txt}, $ntI{$cbI}->{act}, $n2I->{submit1}); $n2I->{sel_file} = \@dwI; $n2I->{frmaction} = $ntI{$cbI}->{url}; } } 
elsif ( $rpI->uri =~/\?sel_file/) { my @tmp = split /\?/, $rpI->uri; my $xkI = $tmp[0]; my $zqI = rsI($tmp[1]); opL "hrf is ".Dumper($zqI) if ffB(); no warnings 'uninitialized';  if ($zqI->{file_action} =~/download/) {   $vnI = "some text here maybe." ; $xsI = 0; } elsif ($zqI->{file_action} =~/delete/) { my $zuI = lhB.xhB().$zqI->{sel_file}; my $qsI = unlink $zuI; $xsI = 0; $vnI = $qsI ? cwM(216, $zuI)  :  cwM(217, $zuI, $! )  ; } elsif ($zqI->{file_action} =~/copy/) { my $bdI = ilB.xhB().$zqI->{sel_file}; my $tkI = lhB.xhB().$zqI->{sel_file}; $tkI =~s/\.smp//;
my $qsI = copy $bdI, $tkI ; $xsI = 0; $vnI = $qsI ? cwM(218, $bdI, $tkI) : cwM(219, $bdI, $tkI, $!) ; } elsif ($xkI =~/start/) { my $tmp = lhB.xhB().$zqI->{sel_file}; my @jwI = `$v1I "$tmp" 2>&1`;  $xsI = 0; $vnI = "Result:\n".join '', @jwI;  } elsif ($xkI =~/stop/) { my @jwI = fzI($zqI->{sel_file}); $xsI = 0; $vnI = "Result:\n".join '', @jwI; } elsif($xkI =~/log/) {  $tmpl_path = $pxI; my $zuI = vjB.'/'.$zqI->{sel_file};  my @tmp = iqU($zuI);  my $tmp = join '', @tmp ;
reI(\$tmp);  $n2I->{pre_content} = cwM(220, $zuI) . $tmp ; $n2I->{plain_title} = $zqI->{sel_file};  $n2I->{refresh} = '<meta http-equiv="Refresh" content="60" />';  } else {  $tmpl_path = $pxI; $xkI =~s|^/||; my @tmp = yaU( "$xkI$zqI->{sel_file}" );  @tmp = rxI(\@tmp) if $xkI =~/cfg/; my $tmp = join '', @tmp; reI(\$tmp);  $n2I->{pre_content} = $tmp; $n2I->{plain_title} = $zqI->{sel_file};  $n2I->{refresh} = '<meta http-equiv="Refresh" content="60" />' if $xkI =~/rpt/;    } }  elsif ( $rpI->uri =~/upload/ ) {  $tmpl_path = $pxI; my ( $spI, $iiI, $dtI, $zvI, $zuI ) = split '\n', $rpI->content(), 5;  
$iiI =~/filename=/;  my $pgI = $';  $pgI =~s/["\r\n]//g;  my $kzI = $pgI;  unless ( $pgI =~/(\.cfg)$/ ) { $pgI =~s/(\.\w*)$//; $pgI .= '.' . b1B;  }                      $spI =~s/[\r\n]//g; $zuI =~s/$spI--//;  my $coI = my $filepath = lhB.xhB().$pgI; $filepath =~s/\\/\\\\/g if kbB(); if ($kzI) {  my $fdI = qmU( $filepath, $zuI ) ;  $n2I->{pre_content} = $fdI ? $fdI : cwM(180, $kzI, $coI); } else { $n2I->{pre_content} = cwM(179); } }
elsif( $rpI->uri->path =~/(\w+)\.txt$/ ) { my $cbI = $1; $n2I->{t_no_display} = $n2I->{t_off} = $n2I->{sbmt_off} = ''; $n2I->{target} = '_blank';  $n2I->{main_pre} = cwM(221, $n2I->{submit1}); $n2I->{frmaction} = 'find_keys'; } elsif ( $rpI->uri =~/find_keys\?/) { my @tmp = split /\?/, $rpI->uri; my $zqI = rsI($tmp[1]); opL "hrf is ".Dumper($zqI) if ffB(); my @tmp1 = `$v1I ! -findkey $zqI->{find_txt} 2>&1`;   $n2I->{main_pre} = join '', @tmp1; }  else {  my $duI = $rpI->uri->path; $duI =~s|^/||; $vnI = $duI; } unless ( $vnI ) {
$xsI = 0; my $plI = ciU();  $n2I->{message} = cwM(308, $plI)  if $plI;   my $mwI = '';   my $q4I = [];   ( $mwI, $q4I ) = raU( $n2I, $tmpl_path ); my $jkI = join '', @$q4I; $vnI = $jkI . join '', @$mwI;  shL( $jkI ) if $jkI ; } else { my $l5I = $xsI ? 'GET file: ' : ''; shL( "$l5I$vnI" ) } return ( $xsI, $vnI );   }  sub ngI { my $jtI = shift; my $u4I = $ntI{$jtI}->{dir}; opendir DH, $u4I 
or  return (aqM.cwM(177, $u4I, $!)); my @dwI = grep{/\.$ntI{$jtI}->{ext}$/} readdir DH; close DH; if ( @dwI ) { @dwI = sort @dwI } else {  @dwI = (cwM(222, $ntI{$jtI}{type}, $ntI{$jtI}->{ext}) );  } return @dwI;  } }  sub pmI { my ($rpI) = @_;      return '' if $rpI->uri->path eq '/';   my $khI = $rpI->headers->authorization_basic();   return $khI ? yqI( $khI) : cwM(223);   } sub gbI { gxU ($_[0]) } sub yqI { my $khI = shift;  
my ($uqI, $qsI) = elU(2, $khI); return $qsI if $qsI;  my $wdI = nmB().xhB().hhB; my $i3I = nmB().xhB().htB; my $zuI = -f $wdI ? $wdI : $i3I;  if (open FH, "<$zuI"){ my @tmp = <FH>; close FH;  my $fuI = quotemeta $uqI; opL " encoded = q$uqI" if ffB();  my @rqI = grep {/^$fuI/} @tmp;  $qsI = @rqI ? '' : cwM(224);  } else { $qsI = cwM(225, $!); shL($qsI);  } return $qsI;  } sub fzI {
my $zuI = shift; $zuI = cpB.xhB().$zuI; my @jwI = yaU( $zuI );  my $xrI = $jwI[0]; chomp $xrI; $xrI =~s/^\s*|\s*$//; return (aqM.cwM(226), @jwI) unless $xrI =~/\d{1,}/;   unlink $zuI or return "ERROR: $!"; return cwM(227, $zuI);   } sub rsI { my $pvI = shift; my ($miI,$avI,$zqI) = ('','',{''=>''}); return $zqI unless $pvI; foreach (split('&', $pvI)) { s/\+/ /g ; ($miI, $avI)= split('=', $_, 2) ; $miI=~ s/%(..)/chr(hex($1))/ge ; $avI=~ s/%(..)/chr(hex($1))/ge ; chomp $avI;
$zqI->{$miI} = $avI ; } return $zqI; }  sub reI { my $pvI = shift; return unless ref $pvI; $$pvI =~s/</\&lt;/g; $$pvI =~s//\&copy;/g; } sub rxI { my $vcI = shift;  my @tmp = ();  foreach (@$vcI) { next if /^\s*\#\#/; if (not /^\s*\#/ and /mailfromp\w+d\s*=/) {  my @tmp1 = split /=/, $_, 2;  $tmp1[1] = $tmp1[1] ? 'xxxxxxxx' : '';   $_ = "$tmp1[0] = $tmp1[1]\n"; }
push @tmp, $_;  } @tmp; } sub END{ xxU(zlI, 'logit', @_); } 1;
__DATA__
uDK9nyw45zSUYyJrTBWBLQ

